<?php
 
 
 

namespace PhpWA\Protocol\Proto\NoiseCertificate;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class Details extends \Google\Protobuf\Internal\Message
{
    


    protected $serial = null;
    


    protected $issuer = null;
    


    protected $expires = null;
    


    protected $subject = null;
    


    protected $key = null;

    












    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getSerial()
    {
        return isset($this->serial) ? $this->serial : 0;
    }

    public function hasSerial()
    {
        return isset($this->serial);
    }

    public function clearSerial()
    {
        unset($this->serial);
    }

    




    public function setSerial($var)
    {
        GPBUtil::checkUint32($var);
        $this->serial = $var;

        return $this;
    }

    



    public function getIssuer()
    {
        return isset($this->issuer) ? $this->issuer : '';
    }

    public function hasIssuer()
    {
        return isset($this->issuer);
    }

    public function clearIssuer()
    {
        unset($this->issuer);
    }

    




    public function setIssuer($var)
    {
        GPBUtil::checkString($var, True);
        $this->issuer = $var;

        return $this;
    }

    



    public function getExpires()
    {
        return isset($this->expires) ? $this->expires : 0;
    }

    public function hasExpires()
    {
        return isset($this->expires);
    }

    public function clearExpires()
    {
        unset($this->expires);
    }

    




    public function setExpires($var)
    {
        GPBUtil::checkUint64($var);
        $this->expires = $var;

        return $this;
    }

    



    public function getSubject()
    {
        return isset($this->subject) ? $this->subject : '';
    }

    public function hasSubject()
    {
        return isset($this->subject);
    }

    public function clearSubject()
    {
        unset($this->subject);
    }

    




    public function setSubject($var)
    {
        GPBUtil::checkString($var, True);
        $this->subject = $var;

        return $this;
    }

    



    public function getKey()
    {
        return isset($this->key) ? $this->key : '';
    }

    public function hasKey()
    {
        return isset($this->key);
    }

    public function clearKey()
    {
        unset($this->key);
    }

    




    public function setKey($var)
    {
        GPBUtil::checkString($var, False);
        $this->key = $var;

        return $this;
    }

}

